
	.ifndef	UCORECTRLI
	.def	UCORECTRLI

	;ucore regs
	
	.def	UcBase				$8000
	
	;leds
	
	.def	UcRSwichtWLedG			$8000
	.def	UuLedR				$8001
	
	;7seg
	
	.def	Uc7SegHex10			$8002
	.def	Uc7SegHex32			$8003
	.def	Uc7SegHex54			$8004
	.def	Uc7SegHex76			$8005
	
	;lcd
	
	.def	Uc7Lcd				$8006
	
	;irq
	
	.def	UcIrqMsk			$8008
	.def	UcIrqMemory			$8009
	
	;timer
	
	.def	UcTimer1LowValue		$800a
	.def	UcTimer1HighValue		$800b
	.def	UcTimer1Ctrl			$800c
		
	.def	UcTimer2LowValue		$800d
	.def	UcTimer2HighValue		$800e
	.def	UcTimer2Ctrl			$800f
		
	;video	
		
	.def	UcVideoRHCountWVideoOn		$8010
	.def	UcVideoRVCountWHSYNC		$8011	
	.def	UcVideoHSTART 			$8012
	.def	UcVideoRPVcountHit		$8012
	.def	UcVideoMEMSTART 		$8013
	.def	UcVideoHSTOP			$8014
	.def	UcVideoHTOTAL 			$8015
	.def	UcVideoVSYNC 			$8016
	.def	UcVideoVSTART			$8017
	.def	UcVideoVSTOP 			$8018
	.def	UcVideoVTOTAL			$8019
	.def	UcVideoLCAdderLow		$801a
	.def	UcVideoLCAdderHigh		$801b
	.def	UcVideoLCAdderLatch		$801c
	.def	UcVideoLCStart 			$801d
	.def	UcVideoHITVCOUNT		$801e
	.def	UcVideoHLOADSTART 		$8020	
	.def	UcVideoHLOADSTOP		$8021	
	.def	UcVideoVLOADSTART 		$8022	
	.def	UcVideoVLOADSTOP 		$8023	
	.def	UcVideoVLOADNEXT		$8024	
	.def	UcVideoMEMStartAdrLow		$8025
	.def	UcVideoMEMStartAdrHigh		$8026
	.def	UcVideoMEMLineOffsetLow		$8027
	.def	UcVideoMEMLineOffsetHigh	$8028
	.def	UcVideoMEMMode			$8029
	.def	UcVideoMEMLatch			$802a
	
	;ps2
	
	.def	UcPs2PortACtrl			$8030
	.def	UcPs2PortBCtrl			$8031
	
	;i2c
	
	.def	UcI2CSoftPortACtrl		$8032
	.def	UcI2CSoftPortBCtrl		$8033
	
	;audio
	
	.def	UcAudioDACBase			$8034
	.def	UcAudioDACLeftHighValue		$8034
	.def	UcAudioDACLeftLowValue		$8035
	.def	UcAudioDACRightHighValue	$8036
	.def	UcAudioDACRightLowValue		$8037
	.def	UcAudioDACCtrlLatch		$8038
	.def	UcAudioDACIrqMinValue		$8039
	
	;hcore
	
	.def	UcHcoreWSelRHCnt		$803c
	.def	UcHcoreAdr			$803d
	.def	UcHcoreData			$803e
	.def	UcHcoreWPushRStatus		$803f
	
	;hcore io
	
	.def	UcHcoreIoBase			$8040
	.def	UcHcoreIoDataLow		$8040
	.def	UcHcoreIoDataHigh		$8041
	.def	UcHcoreIoCmdLow			$8042
	.def	UcHcoreIoCmdHigh		$8043
	.def	UcHcoreIoCtrl			$8044
	
	.def	InHcoreIoDataLow		$0
	.def	InHcoreIoDataHigh		$1
	.def	InHcoreIoCmdLow			$2
	.def	InHcoreIoCmdHigh		$3
	.def	InHcoreIoCtrl			$4
	
	.endif
	
	