
	;this version is only sd card bootable	
	
; sdram
;
;	$d000 0000 	frame buffer 0		(360+16)*226 (1 line space)
;	$d001 4bf0	frame buffer 1		(360+16)*226 (1 line space)
;	$d002 97e0	font colored		24064/2
;	$d002 c6e0	bobs			180224/2
;	$d004 26e0	galaxy			524288/2
;	$d008 26e0	mod			482380/2
;	$d00b d506	crash sample		2234/2

	.def	frameBuffer0	$d0000000
	.def	frameBuffer1	$d0014bf0
	.def	modData		$d00826e0
	.def 	crashSampleData	$d00bd506
	
	;sd header is placed here
	
	.incdir	"F:\git\goldmomo_endlos\assembler_files\ucore\"
	.include "boot_level_sdHeader.s"

	;start at address 32 here
	
	;video off at sd card load
	
	movei	r1,0				;video off
	dexti	>UcVideoRHCountWVideoOn
	movei	r0,UcVideoRHCountWVideoOn
	nop
	st	r0,r1
	
	;read sdcard to sram
	
	dexti	>startBlock
	movei	r0,startBlock
	nop
	rqldi	r0,0	;low
	rqldi	r0,1	;high
	nop
	ld	r2
	ld	r3
	
	addi	r2,64	;64 blocks offset (ucore code/data)
	addtqi	r3,r3,0
	
	;read blocks

	movei	r0,$e0
	movei	r1,$02
	moveih	r0,$97
	moveih	r1,$d0		;r1:r0 = $d002 97e0 (dest start)
	
	movei	r6,sdCardReadBlocks
	nop
	moveih	r6,>sdCardReadBlocks
	
	gpci	r7,2		;
	jmpi	r6,0
	movei	r4,$3e		;3135 blocks-1	delay slot
	nop			;delay slot
	moveih	r4,$c		;delay slot
	nop			;delay slot
	
;***********************************************************************
;* real code
;***********************************************************************
	
	.include 	"spacePilot_se_core.s"	
	
;*********************************************************************
;* functions
;*********************************************************************	
	
	.include	"components\sdCardLoader.s"
		
;*********************************************************************
;* sd data after code segment
;*********************************************************************		
		
	;gfx / sfx
		
	.org	16384
	.incdir "F:\git\goldmomo_endlos\gfx"
	.incbin	"topaz_8x16_colored_1344.dat.raw"					;24064  bytes
	.incbin	"Spaceship_sprites_by_arboris_fixed_256x352x13555_code4.dat.raw"	;180224 bytes
	.incbin	"galaxy_bg_1344_code0.dat.raw"						;524288 bytes
	
	.incdir "F:\git\goldmomo_endlos\sfx"
	.incbin	"space-scream.mod"							;size 482380 Byte
	.incbin "crash.raw"								;size 2234 Bytes
	
	
				