﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace hcore_assembler_library.Opcode
{
    public class Labels
    {
        public Labels()
        { 
        }

        public void addLabel(string name,uint value)
        {
            if (m_labels.ContainsKey(name))
            {
                throw new Exception("Error label '" + name + "' already exists");
            }

            m_labels.Add(name, value);
        }

        public uint getLabel(string name)
        {
            if (!m_labels.ContainsKey(name))
            {
                throw new Exception("Error label '" + name + "' doenst exists");
            }

            return m_labels[name];
        }

        Dictionary<string, uint> m_labels = new Dictionary<string, uint>();
    }
}
