print "\n-> Start build\n\n"

cpuArchitecture = ENV['PROCESSOR_ARCHITECTURE']
prgFilesPath = ""

if cpuArchitecture == "AMD64" 
	prgFilesPath = ENV['ProgramFiles(x86)']
elsif cpuArchitecture == "x86"
	prgFilesPath = ENV['ProgramFiles']
else
	print "Unknown CPU Architecture, stop build\n"
	exit
end

vsExpressPath = prgFilesPath + "\\Microsoft Visual Studio 10.0\\Common7\\IDE\\vcsexpress.exe"
currentDir    = Dir.new(".")

print " CPU Architecture       = '" + cpuArchitecture + "'\n"
print " Program files location = '" + prgFilesPath + "'\n"
print " VS2010 exec location   = '" + vsExpressPath + "'\n"

print " Current directory      = '" + currentDir.path + "'\n\n"

Dir.glob("*.sln") {|solution| 
print " start release build of '#{solution}"  + "'\n"
system("\"#{vsExpressPath}\" #{solution} /build release\n")
print " start debug build of '#{solution}"  + "'\n"
system("\"#{vsExpressPath}\" #{solution} /build debug\n")
}

print "\nFinish build <-\n"

