﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ucore_emulator.core.components.stages
{
    class m1_load : IStage
    {
        public void reset()
        {           
        }

        ucore_bus m_bus;

        public m1_load(ucore_bus bus)
        {
            m_bus = bus;
        }

        public void process(m0_out_m1_in din,out UInt16 dout,s4_out_s5_in dinAlu)
        {
            // alu

            if (dinAlu.mem_we == true)
            {
                m_bus.write(dinAlu.mem_address, dinAlu.mem_data);
            }

            // normal read

            dout = m_bus.read(din.address);
        }
    }
}
