﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ucore_emulator.core.components.stages
{
    public class s1_fetch : IStage
    {
        ucore_bus m_bus;

        public s1_fetch(ucore_bus bus)
        {
            m_bus = bus;
        }

        public void reset()
        {

        }

        public s1_out_s2_in dataOut
        {
            get { return m_out; }
        }

        s1_out_s2_in m_out = new s1_out_s2_in();

        public void process(s0_out_s1_in din, out s1_out_s2_in dout)
        {
            dout = m_out;
            dout.debug_pc = din.address; // only for debug
            dout.data_in = m_bus.read(din.address);
        }
    }
}
