﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_emulator.core.components;
using ucore_emulator.core.components.stages;
using ucore_emulator.core.components.stages_hcore;

namespace ucore_emulator.core.stages_hcore
{
    class s0_fetch : IStage
    {
        ext_bus m_bus;
        public s0_fetch(ext_bus bus)
        {
            m_bus = bus;
        }

        public void reset()
        {

        }

        public hc_s0_out_s1_in dataOut
        {
            get { return m_out; }
        }

        hc_s0_out_s1_in m_out = new hc_s0_out_s1_in();

        internal void process(components.stages_hcore.hc_s4_out_s5_in din, out components.stages_hcore.hc_s0_out_s1_in dout,bool reset)
        {
            dout = m_out;
            if (reset==false)
            { 
                dout.address = din.pc_out;
                m_bus.read(din.pc_out,out dout.data);
            }
        }   
    }
}
