library ieee;
use work.bus_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity hcore_load is	
		port 
		(
				-- 
				
				clk				: in std_logic;
				reset				: in std_logic;
					
				-- 
				
				data				: out STD_LOGIC_VECTOR (31 DOWNTO 0);
				has_data 		: out std_logic;
				ack_data			: in std_logic;
				
				-- recive
				
				data_recive_data	: in std_logic_vector(31 downto 0);
				data_recive_busy	: in std_logic;
				data_recive_ack	: out std_logic											
	
		);
end entity;

architecture rtl of hcore_load is
begin
	
	data 					<= data_recive_data;
	has_data				<= not data_recive_busy;
	data_recive_ack	<= ack_data;
  
end rtl;
