library ieee;
use work.bus_package.all;
use ieee.std_logic_1164.all;
library ieee;
use work.bus_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity ifetch_loader is	
		port 
		(
				-- std
				
				clk				: in std_logic;
				reset				: in std_logic;
				
				-- 
				
				q					: out STD_LOGIC_VECTOR (31 downto 0);
				rdempty 			: out std_logic;
				rdreq				: in std_logic;
				
				-- recive
				
				inst_recive_data	: in std_logic_vector(31 downto 0);
				inst_recive_busy	: in std_logic;
				inst_recive_ack	: out std_logic									
	
		);
end entity;

architecture rtl of ifetch_loader is

begin
	
	q 						<= inst_recive_data;
	rdempty				<= inst_recive_busy;
	inst_recive_ack	<= rdreq;
	
end rtl;