﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ucore_emulator.core.components.stages
{
    public class s5_writeReg : IStage
    {

        UInt16[] m_regs;

        //

        public s5_writeReg(UInt16[] regs)
        {
            m_regs = regs;
            reset();
        }

        public void reset()
        {
          
        }

        public s5_out dataOut
        {
            get { return m_out; }
        }

        s5_out m_out = new s5_out();

        public void process(s4_out_s5_in din)
        {
            m_out.debug_pc = din.debug_pc;

            if ( din.alu_rc_we == true )
            {
                m_regs[din.alu_rc & 0x7] = din.alu_data_c;
            }
        }

    }
}
