library ieee;
use work.ucore_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity multiply is
		port 
		(			
				-- data in
				
				b					: in std_logic_vector(15 downto 0);
				a					: in std_logic_vector(15 downto 0);
							
				-- data out
				
				mul_res			: out std_logic_vector(31 downto 0);
				muls_res			: out std_logic_vector(31 downto 0)
			
															
		);
end entity;

architecture rtl of multiply is		
begin

	mul_res 		<= b * a;
	muls_res 	<= (signed(b) * signed(a));
	
			
end rtl;
